﻿#include <WiFiClientSecure.h>
#define LED_BUILTIN 22         // LED an ESP32 LOLIN32

const char* ssid     = "Bitte eintragen";     
const char* password = "Bitte eintragen";

const char*  server = "script.google.com";  // Server URL
// google script key
const char* key = "AKfycby0T0QaLhodlDRiBNyYSWYwq9bNM-Y17YrzFVeZ8V6im9FL42c"; 

WiFiClientSecure client;
#define debug true

boolean SendeZumGoogle(String URL)
{
  String movedURL;
  String line;

  if (debug)Serial.println("Verbinde zum script.google.com");
  if (!client.connect(server, 443))
  {
    if (debug) Serial.println("Verbindung fehlgeschlagen!");
    return false;
  }

  if (debug) Serial.println("Verbunden!");
  // ESP32 Erzeugt HTTPS Anfrage an Google sheets
  client.println("GET " + URL);
  client.println("Host: script.google.com" );
  client.println("Connection: close");
  client.println();

  // ESP32 empfängt antwort vom Google sheets
  while (client.connected())     // ESP32  empfängt Header
  {
    line = client.readStringUntil('\n');
    if (debug) Serial.println(line);
    if (line == "\r") break;      // Ende Des Headers empfangen
    if (line.indexOf ( "Location" ) >= 0)   // Weiterleitung im Header?
    { // Neue URL merken
      movedURL = line.substring ( line.indexOf ( ":" ) + 2 ) ;
    }
  }

  while (client.connected())    // Google Antwort HTML Zeilenweise Lesen
  {
    if (client.available())
    {
      line = client.readStringUntil('\r');
      if (debug) Serial.print(line);
    }
  }
  client.stop();

  movedURL.trim(); // leerzeichen, \n entfernen
  if (debug) Serial.println("Weiterleitungs URL: \"" + movedURL + "\"");

  if (movedURL.length() < 10) return false; // Weiterleitung nicht da

  if (debug) Serial.println("\n Starte Weiterleitung...");
  if (!client.connect(server, 443))
  {
    if (debug) Serial.println("Weiterleitung fehlgeschlagen!");
    return false;
  }

  Serial.println("Verbunden!");
  // // ESP32 Erzeugt HTTPS Anfrage an Google Tabellen
  client.println("GET " + movedURL);
  client.println("Host: script.google.com");
  client.println("Connection: close");
  client.println();

  while (client.connected()) // ESP32  empfängt Header
  {
    line = client.readStringUntil('\n');
    if (debug) Serial.println(line);
    if (line == "\r")break;
  }
  
  while (client.connected()) // Google Antwort HTML Zeilenweise Lesen
  {
    if (client.available())
    {
      line = client.readStringUntil('\r');
      if (debug) Serial.print(line);
    }
  }
  client.stop();
  if (line == "Ok") return true;
}


void setup()
{
  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, 1);
  Serial.begin(115200);
  Serial.println("Warte auf Verbindung");
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED)
  {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.print("IP Addresse: ");
  Serial.println(WiFi.localIP());
  String URL="https://script.google.com/macros/s/";
  URL += key;
  URL += "/exec?";
  URL += "1_Spalte=100&2_Spalte=200&3_Spalte=300&4_Spalte=400&5_Spalte=500&6_Spalte=600";
  Serial.println(URL);
  if (SendeZumGoogle(URL)) digitalWrite(LED_BUILTIN, 0);
}

void loop()
{
  delay(1);
}